#include "can.h"
#include "msg.h"
#include "benewake_lidar.h"
#include "usart.h"

extern uint16_t g_can_defbound;

// CANʼ
void CAN1_Init(uint32_t Param1, uint32_t Param2)
{
    GPIO_InitTypeDef       GPIO_InitStructure;
    CAN_InitTypeDef        CAN_InitStructure;
    CAN_FilterInitTypeDef  CAN_FilterInitStructure;
    NVIC_InitTypeDef       NVIC_InitStructure;

    uint8_t Mode = CAN_Mode_Normal;
    uint8_t CAN_SJW;
    uint8_t CAN_BS1;
    uint8_t CAN_BS2;
    uint16_t CAN_Prescaler;
    if(Param2 == CAN_Mode_Normal)
    {
        Mode = CAN_Mode_Normal;
    }
    else if(Param2 == CAN_Mode_LoopBack)
    {
        Mode = CAN_Mode_LoopBack;
    }

    if(Param1 == CAN_BOUND_1000)
    {
        CAN_SJW = CAN_SJW_1tq;
        CAN_BS1 = CAN_BS1_9tq;
        CAN_BS2 = CAN_BS2_8tq;
        CAN_Prescaler = 2;
    }
    else if(Param1 == CAN_BOUND_500)
    {
        CAN_SJW = CAN_SJW_1tq;
        CAN_BS1 = CAN_BS1_5tq;
        CAN_BS2 = CAN_BS2_2tq;
        CAN_Prescaler = 9;
    }
    else if(Param1 == CAN_BOUND_250)
    {
        CAN_SJW = CAN_SJW_1tq;
        CAN_BS1 = CAN_BS1_4tq;
        CAN_BS2 = CAN_BS2_3tq;
        CAN_Prescaler = 18;
    }

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_CAN1, ENABLE);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;   //
    GPIO_Init(GPIOA, &GPIO_InitStructure);            //ʼIO

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;    //
    GPIO_Init(GPIOA, &GPIO_InitStructure);           //ʼIO

    //CANԪ
    CAN_InitStructure.CAN_TTCM = DISABLE;         //ʱ䴥ͨģʽ
    CAN_InitStructure.CAN_ABOM = DISABLE;         //Զ߹
    CAN_InitStructure.CAN_AWUM = DISABLE;         //˯ģʽͨ(CAN->MCRSLEEPλ)
    CAN_InitStructure.CAN_NART = ENABLE;          //ֹԶ
    CAN_InitStructure.CAN_RFLM = DISABLE;         //Ĳ,µĸǾɵ
    CAN_InitStructure.CAN_TXFP = DISABLE;         //ȼɱıʶ
    CAN_InitStructure.CAN_Mode = Mode;            //ģʽã mode:0,ͨģʽ;1,ػģʽ;
    //ò
    CAN_InitStructure.CAN_SJW = CAN_SJW;      //ͬԾ(Tsjw)Ϊtsjw+1ʱ䵥λ  CAN_SJW_1tq     CAN_SJW_2tq CAN_SJW_3tq CAN_SJW_4tq
    CAN_InitStructure.CAN_BS1 = CAN_BS1;      //Tbs1=tbs1+1ʱ䵥λCAN_BS1_1tq ~CAN_BS1_16tq
    CAN_InitStructure.CAN_BS2 = CAN_BS2;      //Tbs2=tbs2+1ʱ䵥λCAN_BS2_1tq ~    CAN_BS2_8tq
    CAN_InitStructure.CAN_Prescaler = CAN_Prescaler;          //Ƶϵ(Fdiv)Ϊbrp+1
    CAN_Init(CAN1, &CAN_InitStructure);           //ʼCAN1

    CAN_FilterInitStructure.CAN_FilterNumber = 0;                        //0
    CAN_FilterInitStructure.CAN_FilterMode = CAN_FilterMode_IdMask;      //λģʽ
    CAN_FilterInitStructure.CAN_FilterScale = CAN_FilterScale_32bit;     //32λ
    CAN_FilterInitStructure.CAN_FilterIdHigh = 0x0000;                   //32λID
    CAN_FilterInitStructure.CAN_FilterIdLow = 0x0000;
    CAN_FilterInitStructure.CAN_FilterMaskIdHigh = 0x0000;               //32λMASK
    CAN_FilterInitStructure.CAN_FilterMaskIdLow = 0x0000;
    CAN_FilterInitStructure.CAN_FilterFIFOAssignment = CAN_Filter_FIFO0; //0FIFO0
    CAN_FilterInitStructure.CAN_FilterActivation = ENABLE;               //0

    CAN_FilterInit(&CAN_FilterInitStructure);

    CAN_ITConfig(CAN1,CAN_IT_FMP0,ENABLE);

    NVIC_InitStructure.NVIC_IRQChannel = USB_LP_CAN1_RX0_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 3;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
}

/*************************************************
Function:       CAN1_SendMsg
Description:    CAN͵
Input:          data - Ҫ
                len - ݳ
                id - CAN-ID
Output: none
Return: none
Others: none
*************************************************/
static void CAN1_SendMsg(uint8_t *data,uint16_t len,uint32_t id)
{
    // 
    uint8_t Tran_Mailbox;
    CanTxMsg CAN_TxData;
    uint8_t i = 0;
    uint8_t count = 0;

    CAN_TxData.StdId = id;                  // ñ׼ʾ
    CAN_TxData.IDE   = CAN_Id_Standard;     // ʹñ׼ʶ
    CAN_TxData.RTR   = CAN_RTR_Data;        // ϢΪ֡
    CAN_TxData.DLC   = len;

    for(i = 0; i < len; i++)
    {
        CAN_TxData.Data[i] = data[i];
    }

    Tran_Mailbox = CAN_Transmit(CAN1, &CAN_TxData);
    while(CAN_TransmitStatus(CAN1, Tran_Mailbox) != CAN_TxStatus_Ok)
    {
        count++;
        if(count == 255)
        {
            CAN_DeInit(CAN1);
            CAN1_Init(g_can_defbound, CAN_Mode_Normal);
            Tran_Mailbox = CAN_Transmit(CAN1, &CAN_TxData);
            printf("error can\r\n");
        }
    }
}

/*************************************************
Function:       CAN1_Send
Description:    CAN
Input:          data - Ҫ
                len - ݳ
                id - CAN-ID
Output: none
Return: none
Others: Էݳ8ֽ
*************************************************/
void CAN1_Send(uint8_t *data,uint16_t len,uint32_t id)
{
    uint16_t send_once_len;

    if(len <= 8)
    {
        send_once_len = len;
    }
    else
    {
        send_once_len = 8;
    }
    while(1)
    {
        CAN1_SendMsg(data, send_once_len, id);
        if(len == send_once_len)
        {
            break;
        }
        else
        {
            data += send_once_len;
            len -= send_once_len;
            if(len <= 8)
            {
               send_once_len = len;
            }
            else
            {
                send_once_len = 8;
            }
        }
    }
}


// 
CanRxMsg g_CAN_RxData;

// Ϣȫֱ
extern Msg_Buf g_TaskMessage;

// CANжϺ
void USB_LP_CAN1_RX0_IRQHandler(void)
{
    Msg_Data Msg;
    CAN_Receive(CAN1, CAN_FIFO0, &g_CAN_RxData);
    Msg.msg_type = MSG_TYPE_CE30_DATA;
    Msg.msg_data = 0;
    MSG_Set(&g_TaskMessage, &Msg);
}
