#include "msg.h"
#include "stdio.h"
#include "string.h"
/**
  * @brief  message queueʼ
  * @param  Msg - Ϣ
  * @retval None
  */
void MSG_Init(Msg_Buf *Msg)
{
    Msg->r_idx = 0;
    Msg->w_idx = 0;

    memset((void *)Msg->msgqueue, 0, sizeof(Msg_Data) * MSG_LENGTH);
}

/**
  * @brief  message queueȡһϢ
  * @param  Msg - Ϣ
  * @retval һϢ
  *         msg_type == MSG_NULL - ϢΪ
  */
Msg_Data MSG_Get(Msg_Buf *Msg)
{
    Msg_Data msg;
    // ϢΪ
    __disable_irq();
    if(Msg->r_idx == Msg->w_idx)
    {
        __enable_irq();
        msg.msg_type = MSG_NULL;
        msg.msg_data = 0;
        return msg;
    }
    msg = Msg->msgqueue[Msg->r_idx];
    Msg->r_idx = (++Msg->r_idx) & MSG_MASK;
    __enable_irq();
    return msg;
}

/**
  * @brief  message queueһϢ
  * @param  Msg - Ϣ
  * @param  Message - ҪϢ
  * @retval 0 - ok
  *         -1 - Ϣ
  */
int MSG_Set(Msg_Buf *Msg, Msg_Data *Message)
{
    // Ϣ
    __disable_irq();
    if(((Msg->w_idx + 1) & MSG_MASK) == Msg->r_idx)
    {
        __enable_irq();
        printf("msg queue is full!\r\n");
        return -1;
    }
    Msg->msgqueue[Msg->w_idx] = *Message;
    Msg->w_idx = (++Msg->w_idx) & MSG_MASK;
    __enable_irq();
    return 0;
}

/**
  * @brief  ϢеϢ
  * @param  Msg - Ϣ
  * @retval ϢеϢ
  */
int MSG_Num(Msg_Buf *Msg)
{
    uint16_t w_idx = Msg->w_idx;
    uint16_t r_idx = Msg->r_idx;
    int MsgNum;

    if(w_idx >= r_idx)
    {
        MsgNum = w_idx - r_idx;
    }
    else
    {
        MsgNum = w_idx + MSG_LENGTH - r_idx;
    }

    return MsgNum;
}

