#include "ticks.h"

uint8_t g_SysClk = 120;
volatile uint16_t g_SysTick_Time = 0;
/*************************************************
Function: SysTick_Init
Description: ʼSYSTICK
Input: uint8_t SysClk:ϵͳʱӣλMHZ
Output: none
Return: none
Others:
*************************************************/
void SysTick_Init(uint8_t SysClk)
{
    SysTick->CTRL = 0;
    SysTick->VAL = 0;
    g_SysClk = SysClk;
}

/*************************************************
Function: SysTick_DelayUs
Description: USΪλʱ
Input: uint32_t NUs: ֵΪ139810
Output: none
Return: none
Others:
*************************************************/
void SysTick_DelayUs(uint32_t NUs)
{
    SysTick->CTRL = 0;
    SysTick->VAL = 0;
    SysTick->LOAD = g_SysClk * NUs;
    /* use core clock;
       do not generate interrupt;
       systick enable */
    SysTick->CTRL = 5;

    while((SysTick->CTRL & 0x00010000) == 0)
    {
        ;
    }

    SysTick->CTRL = 0;
}

/*************************************************
Function: SysTick_DelayMs
Description: MsΪλʱ
Input: uint32_t NUs
Output: none
Return: none
Others:
*************************************************/
void SysTick_DelayMs(uint16_t NMs)
{
    uint16_t i;

    for(i = 0; i < NMs; ++i)
    {
        //һĲ
        SysTick_DelayUs(995);
    }
}

/*************************************************
Function: SysTick_DelayCount
Description: ʱ
Input: uint32_t N
Output: none
Return: none
Others:
*************************************************/
void SysTick_DelayCount(uint32_t N)
{
    volatile uint32_t i;

    for(i = 0; i < N; ++i)
    {
        ;
    }
}

/*************************************************
Function: SysTick_Open
Description: ʼʱ
Input:
Output: none
Return: none
Others:
*************************************************/
void SysTick_Open(void)
{
    g_SysTick_Time = 0;
    NVIC_EnableIRQ(SysTick_IRQn);
    SysTick->LOAD = 0xffffff;
    SysTick->VAL  = 0x00;
    SysTick->CTRL = 0x07;
    return;
}

/*************************************************
Function: SysTick_Close
Description: ʱ侭SysTime * 0xffffff + SysCounts
Input: SysTimes
       SysCounts
Output: none
Return: none
Others:
*************************************************/
void SysTick_Close(uint16_t *SysTimes, uint32_t *SysCounts)
{
    SysTick->CTRL = 0x00;
    NVIC_DisableIRQ(SysTick_IRQn);
    *SysTimes = g_SysTick_Time;
    *SysCounts = SysTick->VAL;
    g_SysTick_Time = 0;
    return;
}
