#include "timer.h"
#include "sys.h"
#include "usart.h"
#include "msg.h"
#include "benewake_lidar.h"
#include "led.h"
/********************ⲿ**************/
extern Msg_Buf g_TaskMessage;

// 
static uint16_t online_count = 0;

// ݼ
static uint16_t data_count = 0;

/*************************************************
Function:      Timer_SetCountReset
Description:   
Input:         
Output:        
Return:        
Others:        
*************************************************/
void Timer_SetOnlineCountReset(void)
{
    online_count = 0;
}
/*************************************************
Function:      Timer_SetDataCountReset
Description:   ݼ
Input:         
Output:        
Return:        
Others:        
*************************************************/
void Timer_SetDataCountReset(void)
{
    data_count = 0;
}
/*************************************************
Function:      Timer_Trigger
Description:   
Input:         
Output:        
Return:        
Others:        
*************************************************/
static void Timer_Trigger(void)
{
    if(online_count == 60)
    {
        TIM_Cmd(TIM3, DISABLE);
        TIM_ITConfig(TIM3, TIM_IT_Update, DISABLE);
        online_count = 0;
        lidar_on_flag_reset();
    }
    else
    {
        online_count++;
    }

    if(data_count == 5)
    {
        LED_CE30_DATA = 0;
        data_count = 0;
    }
    else
    {
        data_count++;
    }
}

/*************************************************
Function:      TIM3_IRQHandler
Description:   ʱ3жϷöʱʱ
Input:         
Output:        
Return:        
Others:        
*************************************************/
void TIM3_IRQHandler(void)
{
    if(TIM_GetITStatus(TIM3, TIM_IT_Update) != RESET)
    {
        TIM_ClearITPendingBit(TIM3, TIM_IT_Update);
        Timer_Trigger();
    }
}

/*************************************************
Function:      TIM3_IRQHandler
Description:   ʱ3жϷöʱʱ
Input:         
Output:        
Return:        
Others:        
*************************************************/
void TIM4_IRQHandler(void)
{
    if(TIM_GetITStatus(TIM4, TIM_IT_Update) != RESET)
    {
        TIM_ClearITPendingBit(TIM4, TIM_IT_Update);
        lidar_on_flag_LED();
    }
}
/*************************************************
Function:      TIM3_Int_Init
Description:   ͨöʱ4жϳʼ
Input:         arrԶװֵ
               pscʱԤƵ
Output:        
Return:        
Others:        10msжһ
*************************************************/
void TIM3_Int_Init(uint16_t arr,uint16_t psc)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
    NVIC_InitTypeDef         NVIC_InitStructure;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE);

    TIM_TimeBaseStructure.TIM_Period = arr;
    TIM_TimeBaseStructure.TIM_Prescaler = psc;
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;
    TIM_TimeBaseInit(TIM3, &TIM_TimeBaseStructure);

    NVIC_InitStructure.NVIC_IRQChannel = TIM3_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 3;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

}

/*************************************************
Function:      TIM4_Int_Init
Description:   ͨöʱ4жϳʼ
Input:         arrԶװֵ
               pscʱԤƵ
Output:        
Return:        
Others:        10msжһ
*************************************************/
void TIM4_Int_Init(uint16_t arr, uint16_t psc)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
    NVIC_InitTypeDef         NVIC_InitStructure;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM4, ENABLE);

    TIM_TimeBaseStructure.TIM_Period = arr;
    TIM_TimeBaseStructure.TIM_Prescaler = psc;
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;
    TIM_TimeBaseInit(TIM3, &TIM_TimeBaseStructure);

    NVIC_InitStructure.NVIC_IRQChannel = TIM4_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 3;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

    TIM_Cmd(TIM4, ENABLE);
    TIM_ITConfig(TIM4, TIM_IT_Update, ENABLE);
}
