#include "sys.h"
#include "usart.h"
#include "msg.h"

// PC
volatile uint8_t g_Command_Data[PAYLOAD_LENGTH];

// 
volatile uint8_t g_UsartIndex = 0;

// ж״̬
volatile uint8_t g_UsartStatus = sta_FirstByte;

// PC˷ͻ
AUX_TxBuff_TypeDef g_TxBuff;

// Ϣȫֱ
extern Msg_Buf g_TaskMessage;

// ֧printf
#pragma import(__use_no_semihosting)
struct __FILE 
{ 
    int handle;
}; 

FILE __stdout;
_sys_exit(int x) 
{ 
    x = x; 
} 
int fputc(int ch, FILE *f)
{     
    while((USART1->SR & 0X40) == 0);
    USART1->DR = (uint8_t) ch;
    return ch;
}


// 1ʼ
void USART1_Init(uint32_t bound)
{
    GPIO_InitTypeDef GPIO_InitStructure;
    USART_InitTypeDef USART_InitStructure;

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1 | RCC_APB2Periph_GPIOA, ENABLE);

    //USART1_TX   GPIOA.9
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9; 
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    //USART1_RX   GPIOA.10
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    USART_InitStructure.USART_BaudRate = bound;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;

    USART_Init(USART1, &USART_InitStructure);
    USART_Cmd(USART1, ENABLE);
}

/*************************************************
Function:      USART2_Init
Description:   2ʼ
Input:         1pclk2PCLK2ʱƵ(Mhz)
               2bound
Output:        
Return:        
Others:        
*************************************************/
void USART2_Init(uint32_t Bound)
{
    GPIO_InitTypeDef  GPIO_InitStructure;
    USART_InitTypeDef USART_InitStructure;
    NVIC_InitTypeDef NVIC_InitStructure;

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2,ENABLE);

    //USART2_TX    GPIOA.2
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2; 
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    //USART2_RX    GPIOA.3
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    USART_InitStructure.USART_BaudRate = Bound;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;

    NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 3;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

    USART_Init(USART2, &USART_InitStructure);
    USART_ITConfig(USART2, USART_IT_RXNE, ENABLE);
    USART_Cmd(USART2, ENABLE);
}

// ʹô2͵ָֽ
void USART_SendOneByte(uint8_t Data)
{
    USART_SendData(USART2, (uint8_t)Data);
    while (USART_GetFlagStatus(USART2, USART_FLAG_TC) == RESET)
    {}
}

// ʹô2ݰ  
// עڷͳɹ֮ݰ
void USART_SendBuff(uint8_t *Buff, uint16_t Length)
{
    uint16_t i;

    for(i = 0; i < Length; ++i)
    {
        USART_SendOneByte(Buff[i]);
    }
    return;
}

// 2жϺ
void USART2_IRQHandler(void)
{
    Msg_Data Msg;
    volatile uint8_t res;
    if(USART_GetITStatus(USART2, USART_IT_RXNE) != RESET)
    {
        res = USART_ReceiveData(USART2);
        switch(g_UsartStatus)
        {
            case sta_FirstByte:
                if(0xaa == res)
                    g_UsartStatus = sta_SecondByte;
                else
                    g_UsartStatus = sta_FirstByte;
                break;

            case sta_SecondByte:
                if(0x55 == res)
                    g_UsartStatus = sta_DataByte;
                else
                    g_UsartStatus = sta_FirstByte;
                break;

            case sta_DataByte:
                g_Command_Data[g_UsartIndex++] = res;
                if(PAYLOAD_LENGTH == g_UsartIndex)
                {
                    g_UsartIndex = 0;
                    g_UsartStatus = sta_FirstByte;
                    Msg.msg_type = MSG_TYPE_PC_DATA;
                    Msg.msg_data = 0;
                    MSG_Set(&g_TaskMessage, &Msg);
                }
                break;

            default :
                g_UsartStatus = sta_FirstByte;
                break;
        }
    }
}

