#include "stm32f10x.h"
#include "sys.h"
#include "stdio.h"
#include "ticks.h"
#include "string.h"
#include "string.h"
#include "stdio.h"
#include "stdlib.h"
#include "can.h"
#include "usart.h"
#include "msg.h"
#include "benewake_lidar.h"
#include "timer.h"
#include "led.h"

// ȫ Ϣ
Msg_Buf g_TaskMessage;

// ȫ canbuff
extern CanRxMsg g_CAN_RxData;

// ȫ uartbuff
extern volatile uint8_t g_Command_Data[PAYLOAD_LENGTH];

// Эģʽѡ
uint8_t ProtocolMode = protocol_FALSHHOLD;
uint16_t g_can_defbound = CAN_BOUND_250;

// ʼ
void Init(void)
{
    uint8_t button = 0;
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    SysTick_Init(72);
    USART1_Init(921600);
    USART2_Init(115200);
    Button_Init();
    LED_Init();
    LED_Test();
    TIM3_Int_Init(1000-1,7200-1);
    TIM4_Int_Init(1000-1,7200-1);
    printf("2017.11.20\r\n");
    button = Button_GetValue();
    printf("Button_GetValue = %d \r\n",button);
    if(button == 0)
    {
        ProtocolMode   = protocol_BENEWAKE;
        g_can_defbound = CAN_BOUND_500;
    }
    else
    {
        ProtocolMode   = protocol_FALSHHOLD;
        g_can_defbound = CAN_BOUND_250;
    }
    printf("Init  CAN: %d\r\n",g_can_defbound);
    CAN1_Init(g_can_defbound, CAN_Mode_Normal);
}

int main(void)
{
    Msg_Data Msg;
    Init();

    while(1)
    {
        Msg = MSG_Get(&g_TaskMessage);
        switch(Msg.msg_type)
        {
            // ܵPC
            case MSG_TYPE_PC_DATA:
            {
                uint8_t status = ACK;
                if((lidar_get_error_flag() & ERR_ABNORMAL_FLAG) == ERR_ABNORMAL_FLAG)
                {
                    printf("ERR_ABNORMAL\n");
                    USART_SendOneByte(ERR_ABNORMAL);
                    break;
                }
                // ֹͣģʽ
                if((g_Command_Data[0] & 0x01) == 0x00)
                {
                    Msg_Data msg;
                    status = lidar_stop();
                    USART_SendOneByte(status);
                    do
                    {
                        msg = MSG_Get(&g_TaskMessage);
                    }while(msg.msg_type != MSG_NULL);
                    printf("stop: status = %x\r\n",status);
                }
                // ʼģʽ
                else if((g_Command_Data[0] & 0x01) == 0x01)
                {
                    uint8_t fps = 0x00;
                    uint8_t mode = 0x00;
                    uint8_t line_number = 0x00;
                    uint16_t Xc = 0x00;
                    uint16_t Zc = 0x00;
                    uint16_t protocol = 0x00;

                    // ж
                    line_number = (g_Command_Data[0] & 0xC0) >> 6;

                    // жЭ
                    protocol = (g_Command_Data[0] & 0x30) >> 4;
                    if(g_can_defbound == CAN_BOUND_500)
                    {
                        if(protocol == 0x00)
                        {
                            ProtocolMode = protocol_BENEWAKE;
                        }
                        else
                        {
                            USART_SendOneByte(ERR_PARA);
                            printf("start: ProtocolMode ERR_PARA\r\n");
                            break;
                        }
                    }
                    else
                    {
                        if(protocol == 0x00)
                        {
                            ProtocolMode = protocol_FALSHHOLD;
                        }
                        else if(protocol == 0x01)
                        {
                            ProtocolMode = protocol_MUXING;
                        }
                        else
                        {
                            USART_SendOneByte(ERR_PARA);
                            printf("start: ProtocolMode ERR_PARA\r\n");
                            break;
                        }
                    }

                    // ģʽж
                    mode = (g_Command_Data[0] & 0x0E) >> 1;

                    Xc = g_Command_Data[2] << 8 | g_Command_Data[1];
                    Zc = g_Command_Data[4] << 8 | g_Command_Data[3];
                    fps = g_Command_Data[5];

                    // CE30
                    status = lidar_start(line_number, mode, Xc, Zc, fps);

                    // λ״̬
                    if(mode == 0x00)
                    {
                        USART_SendOneByte(status);
                    }
                    
                    // Դڴӡ״̬
                    printf("start: line_number = %x, mode = %x ,Xc = %d, Zc = %d, fps = %d, Protocol = %d, status = %x\r\n",
                            line_number, mode, Xc, Zc, fps, protocol, status);
                }
                else
                {
                    USART_SendOneByte(ERR_PARA);
                    printf("start: ERR_PARA\r\n");
                }
                break;
            }

            // ܵCAN
            case MSG_TYPE_CE30_DATA:
            {
                // 
                if(lidar_recv_msg(&g_CAN_RxData, ProtocolMode) == NULL)
                {
                    // 
                    break;
                }
                else
                {
                    lidar_send_msg(ProtocolMode);
                }
                break;

            }
            default:  // -1,ϢΪ
            {
                break;
            }
        }
    }
}
